package week05

object Gyakorlat extends App {
  trait SearchTree {
    def contains(value: Int): Boolean
    def inserted(value: Int): SearchTree
  }
  case object Ures extends SearchTree {
    override def toString = "."
    override def contains(value: Int) = false
    override def inserted(value: Int) = Nemures(Ures,value,Ures)
  }
  case class Nemures(left: SearchTree, value: Int, right: SearchTree) extends SearchTree {
    override def toString = "(" + left + value + right + ")"
    override def contains(value: Int) =
      if (value == this.value) true
      else if (value < this.value) left.contains(value)
      else right.contains(value)
    override def inserted(value: Int) =
      if (value == this.value) this
      else if (value < this.value) Nemures( left.inserted(value), this.value, right )
      else Nemures(left, this.value, right.inserted(value) )
  }

  /**
   * Írjunk IntSet osztályt, amiben Int-ek egy halmazát tároljuk, keresőfában, lehessen for comprehensionnal
   * végigmenni az elemein, támogassa üres halmaz létrehozását és új Int beszúrását (immutable, tehát az
   * eredményt egy másik IntSetben adja vissza)! Írjunk hozzá teszteket is.
   */
  val tree5 = Nemures(Ures, 5, Ures)
  val tree11 = Nemures(Ures, 11, Ures)
  val tree1011 = Nemures(Ures,10,tree11)
  val tree12 = Nemures(tree1011, 12, Ures)
  val tree8 = Nemures(tree5,8,tree12)
  println(tree8)

  val tree1 = Ures
    .inserted(8)
    .inserted(12)
    .inserted(10)
    .inserted(5)
    .inserted(11)
  println(tree1)

  val ints = List(8,12,10,5,11)
  val tree2 = ints.foldLeft[SearchTree]( Ures ) {
    (tree,value) => tree.inserted(value)
  }
  println(tree2)

}
